package tech.nevets.vplus;

import net.minecraft.block.*;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemGroup;
import net.minecraft.util.Identifier;
import net.minecraft.util.math.intprovider.IntProvider;
import net.minecraft.util.registry.Registry;
import tech.nevets.vplus.items.VPItemGroups;

import java.util.ArrayList;
import java.util.List;

public class VPBlocks extends Blocks {
    public static final List<Block> BLOCKS = new ArrayList<>();
    public static final Block SAPPHIRE_ORE;
    public static final Block RUBY_ORE;
    public static final Block JADE_ORE;

    public VPBlocks() {
    }

    static {
        SAPPHIRE_ORE = register("sapphire_ore", new OreBlock(AbstractBlock.Settings.of(Material.STONE).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.ALL).getBlock();
        RUBY_ORE = register("ruby_ore", new OreBlock(AbstractBlock.Settings.of(Material.STONE).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.ALL).getBlock();
        JADE_ORE = register("jade_ore", new OreBlock(AbstractBlock.Settings.of(Material.STONE).requiresTool().strength(3.0F, 3.0F)), VPItemGroups.ALL).getBlock();

        ///////////////////\\\\ITERATOR////\\\\\\\\\\\\\\\\\\\

        for (Block block : BLOCKS) {
            for (BlockState blockState : block.getStateManager().getStates()) {
                Block.STATE_IDS.add(blockState);
            }
            block.getLootTableId();
        }
    }

    /*
    Use blockItem.getBlock(); to get instance of the block if needed
     */
    private static BlockItem register(String id, Block block, ItemGroup group) {
        BLOCKS.add(block);
        Registry.register(Registry.BLOCK, new Identifier("vplus", id), block);
        return Registry.register(Registry.ITEM, new Identifier("vplus", id), new BlockItem(block, new Item.Settings().group(group)));
    }

}
